// ======================================================================
//
// MaterialData_d3d_5.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef MATERIAL_DATA_D3D_5_H
#define MATERIAL_DATA_D3D_5_H

// ======================================================================

class Palette;
class Bitmap;
class StaticMaterial;
struct uv_instance;
#include "DirectDraw.h"
#include "Direct3d_5.h"
#include "MaterialData.h"

// ======================================================================

class MaterialData_d3d_5 : public MaterialData
{
private:

	static MaterialData_d3d_5 *head, *tail;
	static u_int               globalTagLRU;
	static u_int               globalToken;
	static u_int               globalTagFlushBatch;

private:

	static void freeSomeTextureSpace(void);

private:

	LPDIRECTDRAWSURFACE  softSurface;
	LPDIRECT3DTEXTURE2   softTexture;
	LPDIRECTDRAWSURFACE  hardSurface;
	LPDIRECT3DTEXTURE2   hardTexture;
	D3DTEXTUREHANDLE     textureHandle;
	MaterialData_d3d_5  *next;
	u_int                tagLRU;
	u_int                token;
	Pixel16              colorKeyColor;
	int                  r, g, b;
	bool                 ignore;
	bool                 translucency;
	bool                 transparency;
	bool                 deleteOnUnload;

private:

	void init(void);
	void load(LPDIRECT3DDEVICE2 device);
	void unload(void);

public:

	static void flushBatch(bool endScene);
	static void remove(void);

public:

	// normal material constructor
	MaterialData_d3d_5(const StaticMaterial *material);

	// special constructor for the movie player
	MaterialData_d3d_5(const uv_instance *uv, u_int32 squareXOffset, u_int32 squareYOffset);

	virtual ~MaterialData_d3d_5(void);

	// setup D3D to use this material
	void  setup(LPDIRECT3DDEVICE2 device);

	int   getR(void) const;
	int   getG(void) const;
	int   getB(void) const;

	bool  ignoreDraw(void) const;
	bool  hasTransparency(void) const;
	bool  hasTranslucency(void) const;
	u_int getToken(void) const;
};

// ======================================================================

inline bool MaterialData_d3d_5::ignoreDraw(void) const
{
	return ignore;
}

// ----------------------------------------------------------------------

inline bool MaterialData_d3d_5::hasTransparency(void) const
{
	return transparency;
}

// ----------------------------------------------------------------------

inline bool MaterialData_d3d_5::hasTranslucency(void) const
{
	return translucency;
}

// ----------------------------------------------------------------------

inline int MaterialData_d3d_5::getR(void) const
{
	return r;
}

// ----------------------------------------------------------------------

inline int MaterialData_d3d_5::getG(void) const
{
	return g;
}

// ----------------------------------------------------------------------

inline int MaterialData_d3d_5::getB(void) const
{
	return b;
}

// ======================================================================

#endif
